#include<bits\stdc++.h>
#define pb push_back
#define eb emplace_back
#define f first
#define s second

#include "ctree.h"
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")
#pragma GCC target("avx2")
*/

using namespace std;

const int MAXN = 3e5;
int n, n2;
vector<int> con[MAXN];
int sz[MAXN];

struct comp {
    bool operator()(int l, int r) {
        return sz[l] < sz[r];
    }
};

pair<int, int> dfs(int curr, int par) { //nodes, operacii
    pair<int, int> currans = {1, 0};
    for (auto to : con[curr]) {
        if (to == par) {
            continue;
        }
        pair<int, int> temp = dfs(to, curr);
        currans.f += temp.f;
        currans.s += temp.s;
    }

    if (curr == par) {
        return currans;
    }

    if (con[curr].size() > 1) {
        vector<int> t(con[curr].size()-1);
        for (int i=0; i<con[curr].size(); i++) {
            if (con[curr][i] == par) {
                continue;
            }
            t[i] = con[curr][i];
        }

        sort(t.begin(), t.end(), comp());
        while (currans.f > n2) {
            currans.f -= sz[t.back()];
            currans.s++;
            t.pop_back();
        }
    }

    //cerr<<curr<<' '<<currans.f<<endl;
    sz[curr] = currans.f;
    return currans;
}

vector<int> solve(int N, vector<int> x, vector<int> y) {
    n = N;
    n2 = n/2;

    for (int i=0; i<n-1; i++) {
        con[i].clear();
    }
    for (int i=0; i<n-1; i++) {
        con[x[i]].pb(y[i]);
        con[y[i]].pb(x[i]);
    }

    vector<int> ans(n, 0);
    for (int i=0; i<n; i++) {
        ans[i] = dfs(i, i).s;
    }
    return ans;
}

