#include<bits/stdc++.h>
#define pb push_back
#define eb emplace_back
#define f first
#define s second

#include "ctree.h"
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")
#pragma GCC target("avx2")
*/

using namespace std;

const int MAXN = 3e5 + 10;
int n, n2;
vector<int> con[MAXN];
int sz[MAXN];

struct comp {
    bool operator()(int l, int r) {
        return sz[l] < sz[r];
    }
};

vector<int> ans;
void dfs(int curr, int par, int currans) {
    //cerr<<curr<<' '<<par<<' '<<currans<<' '<<sz[par]<<endl;

    vector<int> t = con[par];
    sort(t.begin(), t.end(), comp());

    int p = con[par].size()-1;
    while (sz[par] > n2) {
        if (t[p] == curr) {
            p--;
        }
        sz[par] -= sz[t[p]];
        currans++;
        p--;
    }
    ans[curr] = currans;

    int prev = sz[curr];
    sz[curr] = 1;
    for (auto to : con[curr]) {
        sz[curr] += sz[to];
    }

    for (auto to : con[curr]) {
        if (to == par) {
            continue;
        }
        sz[curr] -= sz[to];
        dfs(to, curr, currans);
        sz[curr] += sz[to];
    }
    sz[curr] = prev;
}

void dfsCent(int curr, int par) {
    sz[curr] = 1;

    for (auto to : con[curr]) {
        if (to == par) {
            continue;
        }
        dfsCent(to, curr);
        sz[curr] += sz[to];
    }
}

int findCentroid() {
    dfsCent(0, 0);

    int curr = 0;
    while (true) {
        int mx = 0, pos = 0;
        for (auto to : con[curr]) {
            if (mx < sz[to]) {
                mx = sz[to];
                pos = to;
            }
        }
        if (mx > n2) {
            sz[curr] = n - mx;
            curr = pos;
            sz[curr] = n;
        } else {
            break;
        }
    }
    return curr;
}

vector<int> solve(int N, vector<int> x, vector<int> y) {
    n = N;
    n2 = n/2;

    for (int i=0; i<n; i++) {
        con[i].clear();
    }
    for (int i=0; i<n-1; i++) {
        con[x[i]].pb(y[i]);
        con[y[i]].pb(x[i]);
    }

    int cent = findCentroid();
    /*cerr<<cent<<endl;
    for (int i=0; i<n; i++) {
        cerr<<sz[i]<<' ';
    }cerr<<endl;*/

    ans.resize(n);
    ans[cent] = 0;
    for (auto to : con[cent]) {
        sz[cent] = n - sz[to];
        dfs(to, cent, 0);
        //cerr<<endl;
    }
    return ans;
}

/*
7
0 1
1 2
2 3
2 5
1 4
0 6
7
0 1
1 2
2 3
2 5
1 4
0 6
7
0 1
1 2
2 3
2 5
1 4
0 6
*/
