#include <bits/stdc++.h>
#include "ctree.h"
using namespace std;

vector<int>vec[40000];
bool visited[40000];

long long dfs(int start, int level, int N)
{
    visited[start] = true;
    if(level == N/2) return start;
    for(int i=0; i<vec[start].size(); i++)
    {
        if(!visited[vec[start][i]]) return dfs(vec[start][i], level+1, N);
    }
}
vector<int> solve(int N, vector<int> X, vector<int> Y)
{
    vector<int>ans;
    int st[40000];
    int maxst = 0, root;
    fill_n(st, 40000, 0);

    for(int i=0; i<N-1; i++)
    {
        vec[X[i]].push_back(Y[i]);
        vec[Y[i]].push_back(X[i]);

        st[X[i]]++;
        if(maxst<st[X[i]])
        {
            maxst = st[X[i]];
            root = X[i];
        }

        st[Y[i]]++;
        if(maxst<st[Y[i]])
        {
            maxst = st[Y[i]];
            root = Y[i];
        }
    }
    if(maxst<3)
    {
        int s;
        for(int i=0; i<N; i++)
            if(st[i]==1) {s = i; break;}
        root = dfs(s, 1, N);
        for(int i=0; i<N; i++) ans.push_back(1);
        ans[root]=0;
    }
    else
    {
        for(int i=0; i<N; i++) ans.push_back(0);

        fill_n(visited, N, 0);
        queue<pair<int, int> > q;
        q.push({root, 0});
        pair<int, int>tp;

        while(!q.empty())
        {
            tp = q.front();
            visited[tp.first] = true;
            ans[tp.first] = tp.second;
            q.pop();
            for(int i=0; i<vec[tp.first].size(); i++)
                if(!visited[vec[tp.first][i]])  q.push({vec[tp.first][i], tp.second+1});
        }
    }
    return ans;
}

