#include "ctree.h"

std::vector<int> br;
std::vector<int> perant;

void dfs(int vr, int rod, std::vector<int> X, std::vector<int> Y, int N){
    int i;
    br[vr] = 0;
    perant[vr] = rod;
    for(i=0;i<N;i++){
        if(Y[i] == vr) std::swap(X[i], Y[i]);
        if(X[i] == vr && Y[i] != rod){
            dfs(Y[i], X[i], X, Y, N);
            br[vr]+= br[Y[i]];
        }
    }
    br[vr]++;
}

std::vector<int> solve(int N, std::vector<int> X, std::vector<int> Y){
    std::vector<int> ans;
    std::vector<int> v[1001];
    int i, j, k;
    for(i=0;i<N-1;i++){
        v[X[i]].push_back(Y[i]);
        v[Y[i]].push_back(X[i]);
    }
    br.reserve(N);
    perant.reserve(N);
    for(i=0;i<N;i++){
        int Ans = 0;
        for(j=0;j<v[i].size();j++){
                std::vector<bool> fl;
                fl.reserve(N);
                for(k=0;k<N;k++)  br[k]=-1, fl[k]=0;
                dfs(v[i][j], i, X, Y, N);
                int tbr = 0, st=-1, pos;
                while(tbr < N){
                    for(int k=0;k<N;k++){
                        if(br[k] <= N/2 && fl[k] == 0) tbr++, fl[k]=1;
                        if(br[k] <= N/2 && st < br[k]) st=br[k], pos = k;
                    }
                    for(k = perant[pos];k!=i;k = perant[k]){
                        br[k]-= br[pos];
                    }
                    Ans++;
                }
                Ans--;
        }
        ans.push_back(Ans);
    }
   // dfs(1, 0, X, Y, N);
    //for(i=0;i<N;i++) ans.push_back(perant[i]);

    return ans;
}
