#include<bits/stdc++.h>
#define pb push_back
#define eb emplace_back
#define f first
#define s second

#include "ctree.h"
/*
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")
#pragma GCC target("avx2")
*/

using namespace std;

const int MAXN = 3e5 + 10;
int n, n2;
vector<int> con[MAXN];
int sz[MAXN];

struct comp {
    bool operator()(int l, int r) {
        return sz[l] < sz[r];
    }
};

int dfs(int curr, int par) { //operacii
    sz[curr] = 1;

    int currans = 0;
    for (auto to : con[curr]) {
        if (to == par) {
            continue;
        }
        currans += dfs(to, curr);
        sz[curr] += sz[to];
    }

    if (curr == par) {
        return currans;
    }

    if (con[curr].size() > 1) {
        sort(con[curr].begin(), con[curr].end(), comp());

        auto p = con[curr].end();
        p--;
        while (sz[curr] > n2) {
            sz[curr] -= sz[*p];
            currans++;
            p--;
        }
    }

    //cerr<<curr<<' '<<currans.f<<endl;
    return currans;
}

vector<int> solve(int N, vector<int> x, vector<int> y) {
    n = N;
    n2 = n/2;

    for (int i=0; i<n; i++) {
        con[i].clear();
    }
    for (int i=0; i<x.size(); i++) {
        con[x[i]].pb(y[i]);
        con[y[i]].pb(x[i]);
    }

    vector<int> ans(n);
    for (int i=0; i<n; i++) {
        for (int j=0; j<n; j++) {
            sz[j] = 0;
        }
        ans[i] = dfs(i, i);
    }
    return ans;
}


